#!/bin/bash
#Description: DevKit constants
#Copyright: Copyright © Huawei Technologies Co., Ltd. 2023. All rights reserved.
#History: 2024-01-10 created


HOST_FILE_NOT_EXIT_ERROR='HOST_FILE_NOT_EXIT_ERROR'
HOST_FILE_NOT_TXT_ERROR='HOST_FILE_NOT_TXT_ERROR'
HOST_FILE_TOO_LARGE_ERROR='HOST_FILE_TOO_LARGE_ERROR'
HOST_FILE_PERMISSION_ERROR='HOST_FILE_PERMISSION_ERROR'
SUCCESS=0
RETURN_SUCCESS='SUCCESS'

function force_mk_dir()
{
    local dir=$1
    if [ -d "${dir}" ]; then
        rm -rf "${dir}"
    fi
    mkdir -p "${dir}"
}

function pre_check_host_file() {
    if [ ! -e ${host_file_path} ];then
        echo "${HOST_FILE_NOT_EXIT_ERROR}"
        return
    fi
    test -r ${host_file_path}
    if [[ "$?" -ne "${SUCCESS}" ]]; then
        echo "${HOST_FILE_PERMISSION_ERROR}"
        return
    fi
    file -b ${host_file_path} | grep -q 'text'
    if [[ "$?" -ne "${FAILED}" ]]; then
        echo "${HOST_FILE_NOT_TXT_ERROR}"
        return
    fi
    file_size=$(du -b ${host_file_path} |awk -F " " '{print $1}')
    max_file_size=$((1024 * 1024))
    if [ ${file_size} -gt ${max_file_size} ]; then
        echo "${HOST_FILE_TOO_LARGE_ERROR}"
        return
    fi

    force_mk_dir ${DEBUGGER_ENTRANCE_PATH}/temp/${uuid}
    chmod -R 755 ${DEBUGGER_ENTRANCE_PATH}/temp/${uuid}
    cp -f ${host_file_path} ${DEBUGGER_ENTRANCE_PATH}/temp/${uuid}
    chmod -R 755 ${DEBUGGER_ENTRANCE_PATH}/temp/${uuid}
    echo ${RETURN_SUCCESS}
}

function main() {
    host_file_path="$1"
    uuid="$2"
    host_file_name=$(basename "${host_file_path}")
    DEBUGGER_ENTRANCE_PATH="/usr/bin/devkit/debugger_entrance"
    pre_check_host_file
    cp -f ${host_file_path} ${DEBUGGER_ENTRANCE_PATH}/temp/${uuid}/${host_file_name}
    chmod 755 ${DEBUGGER_ENTRANCE_PATH}/temp/${uuid}/${host_file_name}
}

main "$@"